package com.picfun.bt_freqanalyzer;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.UUID;

import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.os.Handler;

/*********************************************************************
 *   BluetoothŐڑMsNX
 *   64oCgꊇMo[W
 *   [T̓yAꂽ̂̂݁@
 *********************************************************************/
public class BluetoothClient {
	/**** NX萔錾 ********/
	public static final int MESSAGE_STATECHANGE = 1;
	public static final int MESSAGE_READ = 2;
	// SPPUUIDZbg
	private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
	public static final int STATE_NONE = 0;
	public static final int STATE_CONNECTING = 1;
	public static final int STATE_CONNECTED = 2;
	private BluetoothAdapter BTadapter;
	private Handler handler;
	private int state;
	private ConnectThread connecting;
	private ConnectedThread transfer;

	// RXgN^ɂNX̏
	public BluetoothClient(Context context, Handler handler) {
		this.BTadapter = BluetoothAdapter.getDefaultAdapter();
		this.handler = handler;
		state = STATE_NONE;
	}
	
	/******************************************************************/
	/****** Bluetooth̐ڑs ******/
	public synchronized void connect(BluetoothDevice device) {
		if (state == STATE_CONNECTING) {
			if (connecting != null) {				// ɐڑȂ
				connecting.cancel();				// N[Y
				connecting = null;
			}
		}
		if (transfer != null) {						// ɐڑς݂Ȃ
			transfer.cancel();						// N[Y
			transfer = null;
		}
		connecting = new ConnectThread(device);		// ڑXbh𐶐
		connecting.start();							// XbhJn
		setState(STATE_CONNECTING);					// ԕԑ
	}
		
	/******** XbhP ********* BluetoothڑXbh  ****************************/
	private class ConnectThread extends Thread {
		private BluetoothDevice BTdevice;
		private BluetoothSocket BTsocket;

		// UUIDŃ[g[Ƃ̐ڑp\Pbg̐
		public ConnectThread(BluetoothDevice device) {
			try {
				this.BTdevice = device;
				BTsocket = device.createRfcommSocketToServiceRecord(MY_UUID);
			}
			catch (IOException e) {
			}
		}
		// ڑs
		public void run() {
			BTadapter.cancelDiscovery();			// I
			try {
				BTsocket.connect();					// ڑ
			}
			catch (IOException e) {
				setState(STATE_NONE);				// ԕԑ
				try {
					BTsocket.close();				// G[ȂN[Y
				}
				catch (IOException e2) {
				}
				return;
			}
			synchronized (BluetoothClient.this) {	// 
				connecting = null;					// Xe[g
			}
			connected(BTsocket, BTdevice);			// ʐMJn
		}

		// Blutoothڑ؂藣
		public void cancel() {
			try {
				BTsocket.close();
			}
			catch (IOException e) {
			}
		}
	}

	/****** BluetoothʐMJn ******/
	public synchronized void connected(BluetoothSocket socket, BluetoothDevice device) {
		if (connecting != null) {					// ɐڑȂ
			connecting.cancel();					// N[Y
			connecting = null;
		}
		if (transfer != null) {						// ɐڑς݂Ȃ
			transfer.cancel();						// N[Y
			transfer = null;
		}
		transfer = new ConnectedThread(socket);		// MXbh𐶐
		transfer.start();							// XbhJn
		setState(STATE_CONNECTED);					// ԕԑ
	}		
	/********  Xbh2 *********** BluetoothMsXbh  ******************************/
 	private class ConnectedThread extends Thread {
		private BluetoothSocket BTsocket;

		// RXgN^ŏ
		public ConnectedThread(BluetoothSocket bluetoothsocket) {
			this.BTsocket = bluetoothsocket;
		}
		/******** M҂Aobt@f[^o *********/
		public void run() {
			byte[] buf = new byte[64];					// Mobt@̗p
			byte[] Rcv = new byte[64];					// oobt@̗p
			int bytes, Index, i;						// MoCg
			Index = 0;									// oCgJE^Zbg				
			/***** MJԂ[v *****/
			while (true) {
				try {
					// 64oCgM܂ŎMJԂ
					while(Index < 64){					
						InputStream input = BTsocket.getInputStream();
						bytes = input.read(buf);		// Ms
						for(i=0; i<bytes; i++){			// MoCgJԂ
							Rcv[Index]=buf[i];			// obt@Rs[
							if(Index < 64)
								Index++;				// oCgJE^XV
						}
					}
					Index = 0;							// oCgJE^Zbg
					/**** Mf[^Ԃ@Rcvobt@Ɋi[ ****/
					handler.obtainMessage(MESSAGE_READ, 64, -1, Rcv).sendToTarget();
				}
				catch (IOException e) {
					setState(STATE_NONE);				// ԕԑ
					break;
				}
			}
		}
		
		/******** M *******/
		public void write(byte[] buf) {
			try {
				OutputStream output = BTsocket.getOutputStream();
				output.write(buf);						// Ms
			}
			catch (IOException e) {
			}
		}
		/***** N[Y ******/
		public void cancel() {
			try {
				BTsocket.close();
			}
			catch (IOException e) {
			}
		}
	}
	/****** Ms\bh ********/
	public void write(byte[] out) {
		ConnectedThread transfer;
		synchronized (this) {						// Ə
			if (state != STATE_CONNECTED) {
				return;
			}
			transfer = this.transfer;
		}
		transfer.write(out);						// Ms
	}
	
	/***** Ԃ̒ʒm\bh *******/
	private synchronized void setState(int state) {
		this.state = state;
		handler.obtainMessage(MESSAGE_STATECHANGE, state, -1).sendToTarget();
	}
	/****** Ԃ̎擾\bh ******/
	public synchronized int getState() {
		return state;
	}
	/***** Bluetooth̐ؒf\bh ******/
	public synchronized void stop() {
		if (null != connecting) {
			connecting.cancel();
			connecting = null;
		}
		if (null != transfer) {
			transfer.cancel();
			transfer = null;
		}
		setState(STATE_NONE);					// ԕԑ
	}
}
