package com.picfun.bt_freqanalyzer;

import java.util.Set;

import com.picfun.bt_freqanalyzer.R;

import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.LinearLayout;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

/*********************** BluetoothfoCX̗񋓂ƑI ***********************************************/
public class DeviceListActivity extends Activity implements
	AdapterView.OnItemClickListener {

	/*** 萔` ******/
	private final static int WC = LinearLayout.LayoutParams.WRAP_CONTENT;
	private final static int MP = LinearLayout.LayoutParams.MATCH_PARENT;
	public static String DEVICEADDRESS = "deviceaddress";
	private ArrayAdapter<String> DeviceList;
	private BluetoothAdapter BTadapter;

	/**** ANeBreBN ŏɎs郁\bh *********/
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		// _CAO^CgȂ
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		// ߂l̏
		setResult(Activity.RESULT_CANCELED);
		// _CAOCAEg̍쐬
		LinearLayout layout = new LinearLayout(this);
		layout.setOrientation(LinearLayout.VERTICAL);
		setContentView(layout);

		// foCXz
		DeviceList = new ArrayAdapter<String>(this,R.layout.rowdata);

		// Xgr[
		ListView listView = new ListView(this);
		listView.setLayoutParams(new LinearLayout.LayoutParams(MP, WC));
		listView.setAdapter(DeviceList);
		layout.addView(listView);
		listView.setOnItemClickListener(this);

		// u[hLXgV[o[̐
		registerReceiver(receiver, new IntentFilter(BluetoothDevice.ACTION_FOUND));
		registerReceiver(receiver, new IntentFilter(BluetoothAdapter.ACTION_DISCOVERY_FINISHED));

		// Bluetooth[̃XgAbv
		BTadapter = BluetoothAdapter.getDefaultAdapter();			// BTI
		// ɃyAOƂSfoCXXg쐬
		Set<BluetoothDevice> boundeddevices = BTadapter.getBondedDevices();
		if (boundeddevices.size() > 0) {
			for (BluetoothDevice device : boundeddevices) {
				DeviceList.add(device.getName() + "\n" + device.getAddress());
			}
		}
		// pȂ炢񌟍I
		if (BTadapter.isDiscovering() == true) {
			BTadapter.cancelDiscovery();
		}
		// ߂Ĉ莞ԂJn
		BTadapter.startDiscovery();	
	}
	
	/************ Ŕꂽꍇ̃u[hLXgV[o[ *************/
	private final BroadcastReceiver receiver = new BroadcastReceiver() {
		@Override
		public void onReceive(Context context, Intent intent) {
			String action = intent.getAction();

			// Bluetooth[V̏ꍇXgɒǉ
			if (BluetoothDevice.ACTION_FOUND.equals(action)) {
				BluetoothDevice device = intent.getParcelableExtra(BluetoothDevice.EXTRA_DEVICE);
				if (BluetoothDevice.BOND_BONDED != device.getBondState()) {
					DeviceList.add(device.getName() + "\n"+ device.getAddress());
				}
			}
			// Bluetooth[I
			else if (BluetoothAdapter.ACTION_DISCOVERY_FINISHED.equals(action)) {
				android.util.Log.e("", "Bluetooth[");
			}
		}
	};
	
	/**** ANeBreBj ****/
	@Override
	protected void onDestroy() {
		super.onDestroy();
		if (BTadapter != null) {
			BTadapter.cancelDiscovery();
		}
		unregisterReceiver(receiver);
	}
	/***** foCXINbN *****/
	public void onItemClick(AdapterView<?> av, View v, int arg2, long arg3) {
		// Bluetooth[̌̃LZ
		BTadapter.cancelDiscovery();		// I

		// [̃AhX߂lƂĐݒ
		String info = ((TextView) v).getText().toString();
		String address = info.substring(info.length() - 17);
		Intent intent = new Intent();
		intent.putExtra(DEVICEADDRESS, address);
		setResult(Activity.RESULT_OK, intent);
		finish();
	}
}
